//NAME:Caleb Bird
//ID: 1289680
//??References??

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.*;
import java.util.*;


public class javaGenValidIDList {
    public static void main(String[] args) {
	try{
	    if (args.length != 3){
		System.out.println("Usage: TabRndListGen <inputFilename> <outputCount> <outputFilename>");
	    }
	    else{
		//|||PART1|||
		String inputFilename = args[0];
		int outputCount  = Integer.parseInt(args[1]);
		String outputFilename = args[2];	
		BufferedReader buf = new BufferedReader(new FileReader(inputFilename));
		FileWriter fw = new FileWriter(outputFilename);
		ArrayList<String> list = new ArrayList<String>();
		String line = null;
		String[] item;

		//Add items to Array
		while ((line = buf.readLine()) != null) {			
		    //Split line by tab
		    item = line.split("\t", -1);
		    //Add first element (ID)					
		    list.add(item[0]);								    
		}
		//randomize list
		Collections.shuffle(list);						
		
		//||||PART2||||
		//Go thru list, check if ID has more than 10 pages,
		//Keep looping until spesified outputCount has been meet. 
		
		int countMatchingCrit = 0;
		int j = 0;
		ArrayList<String> subList = new ArrayList<String>();
	    
		while(countMatchingCrit < outputCount){
		    System.out.println("Processing item: " + j);
			//current ID being processed
		    String idCurr = list.get(j);
		    //name of bashscript and the arguement				
		    String cmd = "./download_metadata_temp.sh " + idCurr;
		    //run download script		
		    Process p = Runtime.getRuntime().exec(cmd);				

		    p.waitFor();
		    int exitStatus = p.exitValue();
		    //if script execution was successful
		    if(exitStatus == 0){
			//Get numpage value for idCurr
			int numpages = getNumPages(idCurr);
			//if numpages greater than 10 then add this recorded to sublist
	       		if(numpages >= 10){
			    System.out.println("Successful items: " + countMatchingCrit);
			    countMatchingCrit++;
			    subList.add(idCurr);						
			}
		    }
		    else{
			System.err.println("failed to run:" + cmd);
			System.exit(exitStatus);
		    }
		    j++;
		    if(j >= list.size()){break;}
		}
	
		//Write these to new file
		for(int i =0; i < subList.size(); i++){
		    fw.write(subList.get(i) + '\n');
		}
			
		buf.close();
		fw.close();
	    }
	}catch(Exception e){
	    e.printStackTrace();
	}
    }
    //Isolate numpages value in the downloaded xml file (script downloaded this)
    private static int getNumPages(String id){
    	String numpages = null;
	try{
	    //Variables
	    String inputFilename = "metadata_temp.xml";
	    FileReader fileReader = new FileReader(inputFilename);
	    BufferedReader buf = new BufferedReader(fileReader);
	    String line = null;
	    String[] item;

	    //Splits into each record
	    while ((line = buf.readLine()) != null) {						
		if(line.contains("<htd:numpages>")){
		    //Iscolate and store the page number
		    numpages = line.substring(line.indexOf(">")+1, line.lastIndexOf("<"));										
		}											
	    }
	    buf.close();	
	}catch(Exception e){
	    e.printStackTrace();
	}
	return Integer.parseInt(numpages);
    }
}
// Returns 42474

//REFERNECES
//https://stackoverflow.com/questions/12892665/how-to-capture-the-exit-status-of-a-shell-command-in-java
//https://www.javatpoint.com/java-filewriter-class
//https://docs.oracle.com/javase/8/docs/api/index.html?java/io/FileWriter.html
//https://www.geeksforgeeks.org/randomly-select-items-from-a-list-in-java/
//https://codereview.stackexchange.com/questions/146551/picking-10-distinct-words-randomly-from-list-of-unique-words
//http://www.linuxforums.org/forum/programming-scripting/65117-c-c-system-function-analog-java.html

//USE RUN-LIST.txt (modify file it reads using $1 (terminal entry variable (filename))

